## geners 0.0~svn60%2Bds

=== debian/changelog ===
geners (0.0~svn60+ds-4) unstable; urgency=medium

  * Raising CMake minimim required version to build with CMake 4
    (Closes: #1112946)
  * Marking libgeners-dev as Multi-Arch: same
  * Raising Standards version to 4.7.2 (no change)

 -- Pierre Gruet <pgt@debian.org>  Mon, 01 Sep 2025 07:58:57 +0200

geners (0.0~svn60+ds-3) unstable; urgency=medium

  * Raising Standards version to 4.7.0 (no change)
  * Rely on pre-initialized dpkg-architecture variables.

  [ Debian Janitor ]
  * Apply multi-arch hints. + libgeners1: Add Multi-Arch: same.

 -- Pierre Gruet <pgt@debian.org>  Thu, 02 May 2024 23:48:33 +0200

geners (0.0~svn60+ds-2) unstable; urgency=medium

  * Installing icc files, they could be included by other programs

 -- Pierre Gruet <pgt@debian.org>  Fri, 10 Dec 2021 21:14:21 +0100

geners (0.0~svn60+ds-1) unstable; urgency=medium

  * Initial release (Closes: #999424)

 -- Pierre Gruet <pgt@debian.org>  Mon, 15 Nov 2021 17:26:53 +0100

## geners 0.0~svn60+ds

=== tests/Makefile ===
# Set the following variable correctly (where is the UnitTest++ package?)
UTESTPP_DIR = /home/igv/Code/UnitTest++

OFILES_COMMON = test_utils.o SerializableBase.o SerializableBaseReader.o \
                SerializableDerivedA.o SerializableDerivedB.o \
                SerializableDerivedC.o

OTESTS_FAST = test_ClassId.o test_write_item.o test_ArchiveIO.o \
              test_ColumnBuffer.o test_VarPack.o test_tupleIO.o \
              test_ColumnPacker.o test_RowPacker.o test_CPBuffer.o \
              test_forward_listIO.o test_unorderedIO.o test_inheritance.o \
              test_valarrayIO.o test_compressedIO.o test_pseudoIO.o

# OPTIMIZE = -g

# Use the following switch to support C++11 features in g++
# OPTIMIZE = -g -std=c++0x
OPTIMIZE = -std=c++11 -O3

INCLUDES = -I. -I.. -I$(UTESTPP_DIR)/src
CPPFLAGS = $(OPTIMIZE) $(INCLUDES) -Wall -W -Werror -Wno-unused-parameter

LIBS = -L../geners/.libs -lgeners -L$(UTESTPP_DIR) -lUnitTest++ \
       -L/usr/lib64 -L/usr/local/lib -lbz2 -lz -lm

%.o : %.cc
	g++ -c $(CPPFLAGS) -fPIC -MD $< -o $@
	@sed -i 's,\($*\.o\)[:]*\(.*\),$@: $$\(wildcard\2\)\n\1:\2,g' $*.d

all: fast fast_run

fast: test_main.o $(OTESTS_FAST) $(OFILES_COMMON)
	rm -f $@
	g++ $(OPTIMIZE) -fPIC -o $@ $^ $(LIBS)

fast_run: fast
	./fast

PROGRAMS = hugePack_col.cc hugePackRead_col.cc hugePack_row.cc \
           hugePackRead_row.cc printCatalog.cc searchCatalog.cc

BINARIES = $(PROGRAMS:.cc=)

binaries: $(BINARIES)

$(BINARIES): % : %.o $(OFILES_COMMON); g++ $(OPTIMIZE) -fPIC -o $@ $^ $(LIBS)

clean:
	rm -f fast $(BINARIES) *.out core.* *.o *.d *~ *.gsbd *.gsbmf

-include test_main.d
-include $(OFILES_COMMON:.o=.d)
-include $(OTESTS_FAST:.o=.d)
-include $(PROGRAMS:.cc=.d)

=== debian/control ===
Source: geners
Maintainer: Pierre Gruet <pgt@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libbz2-dev,
               zlib1g-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/geners
Vcs-Git: https://salsa.debian.org/debian/geners.git
Homepage: https://geners.hepforge.org/
Rules-Requires-Root: no

Package: libgeners1
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Multi-Arch: same
Description: generic serialization library for C++ (shared library)
 The Generic Serialization library is designed to address the problem of C++
 object persistence in situations where the most typical data access pattern is
 "write once read many" (WORM). "Geners" is a set of tools and conventions
 which allows its users to develop C++ classes that can be converted to and
 from a storable stream of bytes in a well-organized and type-safe manner.
 Serialization of STL containers is supported, including the ones added in the
 C++11 standard. Independent versioning of each class definition is allowed.
 .
 Among others, compared to the boost serialization package, Geners archives
 provide random access to stored objects and can be used to create and
 serialize very large archive-based objects. Yet, only binary archives are
 implemented, and implementing non-intrusive serialization is less transparent.
 .
 This package contains the shared library.

Package: libgeners-dev
Architecture: any
Section: libdevel
Depends: libgeners1 (= ${binary:Version}),
         libbz2-dev,
         zlib1g-dev,
         ${misc:Depends}
Multi-Arch: same
Description: generic serialization library for C++ (development package)
 The Generic Serialization library is designed to address the problem of C++
 object persistence in situations where the most typical data access pattern is
 "write once read many" (WORM). "Geners" is a set of tools and conventions
 which allows its users to develop C++ classes that can be converted to and
 from a storable stream of bytes in a well-organized and type-safe manner.
 Serialization of STL containers is supported, including the ones added in the
 C++11 standard. Independent versioning of each class definition is allowed.
 .
 Among others, compared to the boost serialization package, Geners archives
 provide random access to stored objects and can be used to create and
 serialize very large archive-based objects. Yet, only binary archives are
 implemented, and implementing non-intrusive serialization is less transparent.
 .
 This package contains the headers and the static library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/architecture.mk

# SOVERSION is chosen by us, initially set to the first digit of the version in
# NEWS. The version is automatically computed by reading the NEWS file.
SOVERSION_GENERS=1
VERSION_GENERS=$(shell grep "Version[[:blank:]][[:digit:].]*" NEWS | sed 's/Version[[:blank:]]\([[:digit:].]*\)[[:blank:]].*/\1/' | head -n1)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	# Using our hand-made CMakeLists.txt to build with CMake.
	cp debian/CMakeLists.txt .
	dh_auto_configure -- \
	        -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
	        -DCMAKE_INSTALL_PREFIX="/usr" \
	        -DSOVERSION_GENERS="$(SOVERSION_GENERS)" \
	        -DVERSION_GENERS="$(VERSION_GENERS)"

override_dh_auto_clean:
	dh_auto_clean
	# Removing the hand-made CMakeLists.txt.
	-rm CMakeLists.txt

=== debian/watch ===
version=4

opts="mode=svn, pgpmode=none, \
      repack, repacksuffix=+ds, compression=xz, \
      dversionmangle=s/\+ds//" \
 https://svn.hepforge.org/generssvn/trunk HEAD
